%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% (c) Hossam A.  H.  Fahmy 
%
%    This work may be distributed and/or modified under the
%    conditions of the LaTeX Project Public License, either version 1.3
%    of this license or (at your option) any later version.
%    The latest version of this license is in
%      http://www.latex-project.org/lppl.txt
%    and version 1.3 or later is part of all distributions of LaTeX
%    version 2005/12/01 or later.
% 
% This work has the LPPL maintenance status `maintained'.
%
% The Current Maintainer of this work is Hossam A. H. Fahmy.
% (hfahmy@arith.stanford.edu)
%
% This work consists of all the files listed in alqalam_manifest.txt.
%
% Based on the original work of the arabtex package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 17 Shaban 1427, 10 Sep 2006
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% qacolor.sty
% AlQalam macros for coloring 
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Based on the work of:
%  Karel Mokry
%  student of Mathematics
%  Charles University, Prague
%  jazyk@artax.karlin.mff.cuni.cz
%  http://artax.karlin.mff.cuni.cz/~jazyk/
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% version history for the original work: 
%   16.11.2000 version 1.0
%     - first released version
%   6.11.2001 version 1.1
%   fixed two problems with version 1.0    
%     - problems with output - looked 'broken'
%     - output from verses.sty was full of garbage
%   thanks to Daddi Addoun Yacine who reported this bugs
%
% version history for qacolor:
%  15.01.1427 version 1.0
%  17.08.1427 version 1.1 (to color qalqalah, noon, meem, ...)

\ifx \Ar@bColorize \undefined \else \typeout{qacolor can be loaded only Once!}\expandafter \endinput
\fi % load only once

\a@ident {qacolor.sty} {1.1 coloring for AlQalam} {17.08.1427}

% Karim Sharawy had this as a message. 
%\typeout{using qacolor.sty version 1.1 by Kareem Sharawy, depends on color.sty - automatically loaded}
%I think there is no need for extra information on the screen. (Hossam)

%
% depends on color...
%

\usepackage{color}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% color definitions for Arabic
%
% Not used. At this moment.
\gdef\Def@aultColor{blue}
%
% setting colors
%
\gdef\set@rabcolor#1{\gdef\ar@bcolor{#1}}
\gdef\no@rabcolor{\let\ar@bcolor\undefined}

%\gdef\Ar@bColorize#1{\ifx\ar@bcolor\undefined{#1}\else\textcolor{\ar@bcolor}{#1}\fi}
\gdef\Ar@bColorize#1{\ifx\ar@bcolor\undefined#1\else\textcolor{\ar@bcolor}{#1}\fi}
%
% useful switches to set/unset coloring
%
\gdef\coldia#1{\colfatha{#1}\colkasra{#1}\coldamma{#1}%
               \colquran{#1}\colammad{#1}%
               \colzwarakay{#1}\colbars{#1}%
               \colsukun{#1}\colshadda{#1}\colwasla{#1}}
\gdef\colother#1{\colhamza{#1}\colmadda{#1}}
\gdef\colarab#1{\coldia{#1}\colother{#1}}
\gdef\colall#1{\colarab{#1}\colisolated{#1}\colend{#1}\colbeginning{#1}\colmiddle{#1}
\colqalqala{#1}\colmnshadd{#1}\colmadd{#1}\colrhz{#1}}
\gdef\colwakf#1{\colwakf{#1}}
%
\gdef\nocoldia{\nocolfatha\nocolkasra\nocoldamma%
                 \nocolquran\nocolammad%
                 \nocolzwarakay\nocolbars%
                 \nocolsukun\nocolshadda\nocolwasla}
\gdef\nocolother{\nocolhamza\nocolmadda}
\gdef\nocolarab{\nocoldia\nocolother}
\gdef\nocolall{\nocolarab\nocolisolated\nocolend\nocolbeginning\nocolmiddle}
\gdef\nocolwakff{\nocolwakf}
%
% How to create similar macros and definitions
%
\gdef\@@create#1{%
\expandafter\gdef\csname col#1\endcsname##1{\expandafter\gdef\csname c@@l#1\endcsname{##1}}%
\expandafter\gdef\csname nocol#1\endcsname{\expandafter\let\csname c@@l#1\endcsname\undefined}%
}

\gdef\@create#1{%
\DeclareOption{#1}{\@@create{#1}}%
%                                                                                        !!!!!! not \undefined !!!
\expandafter\gdef\csname col@#1\endcsname##1{\expandafter\ifx\csname c@@l#1\endcsname\relax\no@rabcolor\else\expandafter\set@rabcolor{\csname c@@l#1\endcsname}\fi\Ar@bColorize{##1}}
}

%
% Let's define everything we need.
%
\@create{hamza} \@create{kasra}  \@create{damma}    \@create{fatha}
\@create{quran} \@create{shadda} \@create{madda}    \@create{sukun}
\@create{wasla} \@create{ammad}  \@create{zwarakay} \@create{bars}
%
%
%
%
%
{\catcode `\^ 7 \catcode `\ =9 \catcode `\^^M=9 \catcode `\^^I=9
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\newtoks\ar@bcolor
%\newcount\ar@bcolorN
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% let's redefine some definitions.
%
% from qaboxes.sty
%
% dynamic definitions for Arabic
\gdef \def@arabaccent {% define accent macros for Arabic
\gdef \put@fatha     {\put@acc@hi {\col@fatha\char \a@fatha        }}
\gdef \put@damma     {\put@acc@hi {\col@damma{\char \a@damma}        }}
\gdef \put@kasra     {\put@acc@lo {\col@kasra{\char \a@kasra}        }}
\gdef \put@shadda    {\put@acc@hi {\col@shadda{\char \a@shadda}      }}
\gdef \put@hamza     {\put@hi     {\col@hamza{\char \a@hamza}        }}
\gdef \put@hamzalo   {\put@lo     {\col@hamza{\char \a@hamza}        }}
\gdef \put@madda     {\put@hi     {\col@madda{\a@madda@up}           }}
\gdef \put@sukun     {\put@acc@hi {\col@sukun{\char \a@sukun}        }}
\gdef \put@wasla     {\put@acc@hi {\col@wasla{\char \a@wasla}        }}
\gdef \put@fathatan  {\put@acc@hi {\col@fatha{\char \a@fathatan}     }}
\gdef \put@dammatan  {\put@acc@hi {\col@damma{\char \a@dammatan}     }}
\gdef \put@kasratan  {\put@acc@lo {\col@kasra{\char \a@kasratan}     }}
\gdef \put@fathaspec {\put@acc@hi {\col@quran{\char \a@quran@alif}   }}
\gdef \put@kasraspec {\put@acc@lo {\col@quran{\char \a@quran@alif}   }}
\gdef \put@dammaspec {\put@acc@hi {\col@quran{\char \a@quran@alif}   }}
\gdef \put@ammad     {\put@acc@hi {\col@ammad{\char \a@ammad}        }}
\gdef \put@zwarakay  {\put@acc@hi {\col@zwarakkay{\char \a@zwarakay} }}
\gdef \put@barslo    {\put@lo     {\col@bars{\char \a@bars}          }}
\gdef \put@kh@hamza  {\put@hi     {\col@hamza{\char \a@hamza}        }}
\gdef \put@kl@hamza  {\put@lo     {\col@hamza{\char \a@hamza}        }}
\gdef \put@kh@hamz@s {\put@hi     {\col@hamza{\char \a@hamz@s}       }}
\gdef \put@kl@hamz@s {\put@lo     {\col@hamza{\char \a@hamz@s}       }}

%H% the Quranic diacrtic
\gdef \put@q@sly    {\put@spmrk@hi {\col@wakf{\char \a@q@sly}  }}
\gdef \put@q@qly    {\put@spmrk@hi {\col@wakf{\char \a@q@qly}  }}
\gdef \put@q@lazm   {\put@spmrk@hi {\col@wakf{\char \a@q@lazm}  }}
\gdef \put@q@mam    {\put@spmrk@hi {\col@wakf{\tiny\char \a@q@mam}   }}
\gdef \put@q@j      {\put@spmrk@hi {\col@wakf{\char\a@q@j}      }}
\gdef \put@q@qdots  {\put@spmrk@hi {\col@wakf{\char \a@q@qdots} }}
\gdef \put@q@sakt   {\put@spmrk@hi {\col@wakf{\tiny\char \a@q@sakt}  }}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
}}% end of dynamic definitions for Arabic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%
\@create{isolated}\@create{beginning}\@create{middle}\@create{end}
\@create{wakf}\@create{qalqala}\@create{mnshadd}\@create{madd}\@create{rhz}
%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% from qawrite.sty - not
%
% normal characters
%



\def \ac@iso #1*{% isolated shape                        % m *
\put@skel 0\a@f@iso #1*\a@norm }

\def \ac@end #1*{% final shape                           % m *
\put@skel 1\a@f@end#1*}

\def \ac@mid #1*{% medial shape                          % m *
\put@skel 2\a@f@mid #1*}

\def \ac@beg #1*{% initial shape                         % m *
\put@skel 3\a@f@beg #1*\a@norm }
%
% ligatures
%
\def \lig@iso #1*#2*{% isolated shape                        % m1 * m2 *
\put@lig@skel 0\a@f@iso #1*#2*\a@norm }

\def \lig@end #1*#2*{% final shape                           % m1 * m2 *
\put@lig@skel 1\a@f@end #1*#2*}
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%

%
% Options
%
% when using \@create{foo}, \DeclareOption{\foo}{...} is created.

\DeclareOption{dia}{\ExecuteOptions{damma,kasra,fatha,quran,ammad,zwarakay,bars,sukun,shadda,wasla}}
\DeclareOption{other}{\ExecuteOptions{hamza,madda}}
\DeclareOption{arab}{\ExecuteOptions{dia,other}}
\DeclareOption{all}{\ExecuteOptions{arab,isolated,end,beginning,middle,qalqala,mnshadd,madd,rhz}}
\DeclareOption{wakff}{\ExecuteOptions{wakf}}

\ProcessOptions

\endinput
